<?php

/*  Copyright 2012 Tesliuk Igor  (email : tigor@tigor.org.ua)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class YWM {
public $hostlist;

private $token;
private $href;
private $error;
private $uid;
private $host_id;
private $virused;
private $last_access;
private $updated;

public function YWM(){
	$this->error = '';
}

public function is_virused() {

	if ('false' == $this->virused)
		{
		return false;
		} else {
		return true;
		}
}

public function accessed(){
	return $this->last_access;
}


public function auth($token){
	if ($token != ''){	
			$this->token = $token;
			return true;
		} else {
			$this->error = 'Empty token!'.' ->'.$this->error;
		}
}
	
public function is_ok() {
	if (($this->error == '') and ($this->token != ''))
		{
		return true;
		}else{
		return false;
		}
	
}
	
	
public function set_ids() {
	$return = true;
	$url = '/api/me';
	$ch = curl_init();
	$header = array(
        "GET ".$url." HTTP/1.1",
        "Host: webmaster.yandex.ru",
        "Authorization: OAuth ".$this->token,
    ); 
	
	curl_setopt($ch, CURLOPT_URL, 'https://webmaster.yandex.ru'.$url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
	$respond = curl_exec($ch);
	
	
	if(curl_errno($ch))
    {
		$this->error = 'Error in set_id():'.curl_errno($ch).' ->'.$this->error;
		return false;
	} else {
		$response = curl_getinfo($ch);
		$this->uid = substr($response['url'],32);
		return true;
	}
}

public function clear() {
	$hostlist = '';
	$token = '';
	$href = '';
	$error = '';
	$uid = '';
	$host_id = '';
	$virused = '';
	$last_access = '';
	$updated = 0;
}

public function set_hostid($my_host) {
	$return = false;
	

	$service = $this->yget('/api/'.$this->uid);
	// var_dump($service );
	if ($service)
	{
		$url = $service->workspace->collection->attributes()->href;
		$url = substr($url,27);
		$hostlist = $this->yget($url);
		if ($hostlist)
		{
			
			foreach($hostlist->children() as $host)
			{
				
				
				if ((string)$host->name == $my_host)
				{	
					
					$return = true;
					$this->href = (string)$host->attributes()->href;
					$this->virused = (string)$host->virused;
					$this->last_access = (string)$host->{'last-access'};
					
					$this->hostlist[(string)$host->name] = (string)$host->name;
					
				} else {
				$this->hostlist[(string)$host->name] = (string)$host->name;
				}
			}
			
			return $return;
		} else {
			$this->error = 'Failed to get Hostlist -> '.$this->error;
			return false;
		}
	
	} else {
		$this->error = 'Failed to get Service document->'.$this->error;
		return false;
	}
	
}


public function get_error(){
	return $this->error;
	
}

private function yget($url){
	$ch = curl_init();
	
	$header = array(
            "GET ".$url." HTTP/1.1",
            "Host: webmaster.yandex.ru",
            "Authorization: OAuth ".$this->token,
        ); 
	curl_setopt($ch, CURLOPT_URL, 'https://webmaster.yandex.ru'.$url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
	$respond = curl_exec($ch);

	
	if(curl_errno($ch))
    {
		$return = false;
		$this->error = 'Curl error:'.curl_errno($ch).' ->'.$this->error;
    } else {
		$http_code = (int)curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if ($http_code != 200)
		{
			$this->error = 'Bad Http code: '.$http_code.' ->'.$this->error;
			$return = false;
		} else {
			$return = new SimpleXMLElement($respond);
		}
		
	}
	
	return $return;
}
	
}	
?>